/* 
 * CinemaSix Media Player
 * Copyright (c) 2004, Sujal Patel
 * Copyright (c) 2004-2005, Andrew Oliver
 * $Id: InputStreamTS.cpp,v 1.5 2005/05/21 19:28:18 aoliver Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

#include <cascade/Cascade.h>
#include "MPEGDecoderExperimental.h"
#include <cascade/util/CascadeFSObject.h> 
#include <cascade/util/CascadeDirBrowser.h> 
#include <cascade/util/CascadeFile.h> 

#include "dvbpsi/dvbpsi.h"
#include "dvbpsi/psi.h"
#include "dvbpsi/pat.h"
#include "dvbpsi/descriptor.h"
#include "dvbpsi/pmt.h"

#include "File.h"
#include "InputStreamTS.h"


extern int XXXSMP_too_late_at_night_eof_hack;


InputStreamTS::InputStreamTS(File *f)
{
    m_pInput = f;
}


InputStreamTS::~InputStreamTS()
{
}


bool
InputStreamTS::Open(const char* fn)
{
    return m_pInput->m_OK;
}


int
InputStreamTS::GetNextTSPacket(u_int8_t *buffer)
{
    bool did_resync;

again:
    if (XXXSMP_too_late_at_night_eof_hack) return 0;
    did_resync = false;

    if (!m_pInput->GetBytes(buffer, 188))
	goto goteof;

    while (buffer[0] != 0x47) {
	if (!m_pInput->GetBytes(buffer, 1))
	    goto goteof;
	did_resync = true;
    }
    if (did_resync == true) {
	if (!m_pInput->GetBytes(buffer+1, 187))
	    goto goteof;
    }

    return 1;
goteof:
    if( m_pInput->TryNextFile() ) {
	goto again;
    } else {
	XXXSMP_too_late_at_night_eof_hack = 1;
	return 0;
    }
}

/*
void InputStreamTS::SeekRelative(long long llOffsetInBytes) {
  long long llNewOffset = m_pInput->GetPosition() + llOffsetInBytes;

  m_pInput->SeekToPosition(llNewOffset);
}
*/

bool InputStreamTS::ForwardChapter() {
    // Jump forward 30 seconds
    // 30 seconds = 383232 packets = 72047616 bytes
    
    //SeekRelative(72047616);
    m_pInput->Seek(72047616);

    return true;
}

bool InputStreamTS::BackwardChapter() {
    // Jump backward 10 seconds
  // 10 seconds = 127744 packets = 24015872  bytes
    
    //SeekRelative(-24015872);
    m_pInput->SeekB(24015872);

    return true;
}
