/* 
 * CinemaSix Media Player
 * Copyright (c) 2004, Sujal Patel
 * Copyright (c) 2004-2005, Andrew Oliver
 * $Id: InputStreamTS.h,v 1.5 2005/05/21 19:26:48 aoliver Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#ifndef _INPUTSTREAMTS_H_
#define _INPUTSTREAMTS_H_

#include "InputStream.h"

class File;

class InputStreamTS : public InputStream
{
public:
    InputStreamTS(File *f);
    virtual ~InputStreamTS();
    virtual bool Open(const char* source);
    virtual int GetNextTSPacket(u_int8_t *buffer);
    virtual bool XXXSMPHasPATPMT() { return true; }
    virtual bool HasValidPCR() { return true; }
    virtual bool SupportChapters() { return true; }
    virtual bool ForwardChapter();
    virtual bool BackwardChapter();
private:
    File* m_pInput;
};

#endif
